#include "stdafx.h"
#include "KDC.h"

using namespace std;

CKDC g_cKDC;

CKDC::CKDC(void)
: m_cnBaseCode(932)
{
	m_nMaxLength=4096;
	m_bUseEncodeK2J=true;
}

CKDC::~CKDC(void)
{
}

bool CKDC::preKDC(LPSTR szJpnDest, int nBufSize, LPCSTR cszJpnSrc)
{
	szJpnDest[0]='\0';
	bool m_bIsChanged=false;
	if(cszJpnSrc[0]=='\0') return false;

	int nLen=strlen(cszJpnSrc);

	vector<int> ar_HeadList;
	for(int nIdx=0;nIdx<nLen;nIdx++)
	{
		
		if(IsDBCSLeadByteEx(m_cnBaseCode,cszJpnSrc[nIdx]))
		{
			ar_HeadList.push_back(nIdx+nBufSize);
			nIdx++;
		}
		else
		{
			ar_HeadList.push_back(nIdx);
		}
	}

	m_strJpnTemp=cszJpnSrc;
	string strJpnDest;

	int nPrevPos=0;
	for(int nIdx0=0;nIdx0<ar_HeadList.size();nIdx0++)
	{
		for(int nIdx1=ar_HeadList.size()-1;nIdx1>=nIdx0;nIdx1--)
		{
			string strTemp;
			int nPos0=ar_HeadList[nIdx0]%nBufSize;
			int nPos1=ar_HeadList[nIdx1]%nBufSize;
			int nHead1=ar_HeadList[nIdx1]/nBufSize;

			if(nPos1+nHead1-nPos0+1>m_nMaxLength) continue;

			if(FindWord(m_strJpnTemp.substr(nPos0,nPos1+nHead1-nPos0+1),&strTemp))
			{
				//ġ 
				strJpnDest+=m_strJpnTemp.substr(nPrevPos,nPos0-nPrevPos);
				nPrevPos=nPos1+nHead1+1;

				// ġ
				strJpnDest+=strTemp;

				bool m_bIsChanged=true;
			}
		}
	}
	strJpnDest+=m_strJpnTemp.substr(nPrevPos,nLen-nPrevPos);

	strcpy_s(szJpnDest,nBufSize,strJpnDest.c_str());

	return m_bIsChanged;
}

bool CKDC::postKDC(LPSTR szKorDest, int nBufSize, LPCSTR cszKorSrc)
{
	strcpy_s(szKorDest,nBufSize,cszKorSrc);

	if(!m_bIsChanged)
	{
		if(m_bUseEncodeK2J)
		{
			LPSTR szJpnTemp = new char[nBufSize];
			EncodeK2JString(szJpnTemp,cszKorSrc);
			AddWord(szJpnTemp,m_strJpnTemp.c_str());
			delete[] szJpnTemp;
		}
		else
		{
			AddWord(cszKorSrc,m_strJpnTemp.c_str());
		}
	}

	return m_bIsChanged;
}

void CKDC::EncodeK2JString(LPSTR szJpn,LPCSTR cszKor)
{

	//Encodeκ(ATCode Plugin )
	int len = (int)strlen(cszKor);
	int i = 0;
	while( i<len )
	{
		if( 0x80 <= (BYTE)cszKor[i] )
		{
			char tmpbuf[3];
			tmpbuf[0] = cszKor[i];
			tmpbuf[1] = cszKor[i+1];
			tmpbuf[2] = '\0';
			EncodeK2J(tmpbuf, &szJpn[i]);
			i++;
		}
		else
			szJpn[i] = cszKor[i];
		i++;
	}
	szJpn[i] = '\0';
}

//EncodeԼ ATCode Plugin 
BOOL CKDC::EncodeK2J(LPCSTR cszKorCode, LPSTR szJpnCode)
{
	BOOL bRetVal = FALSE;

	if(cszKorCode && cszKorCode && 0xA0 <= (BYTE)cszKorCode[0] && 0xA0 <= (BYTE)cszKorCode[1])
	{
		// 889F~9872, 989F~9FFC, E040~EAA4, ED40~EEEC
		// 95~3074, 3119~4535, 16632~18622, 19089~19450
		BYTE hiKorByte = (BYTE)cszKorCode[0];
		BYTE loKorByte = (BYTE)cszKorCode[1];

		//  ('')
		if(hiKorByte==0xBE && loKorByte==0xC6){ hiKorByte = 0xA8; loKorByte = 0xA1; }
		//  ('')
		if(hiKorByte==0xB7 && loKorByte==0xB8){ hiKorByte = 0xA8; loKorByte = 0xA2; }
		//  ('')
		if(hiKorByte==0xB8 && loKorByte==0xD5){ hiKorByte = 0xA8; loKorByte = 0xA3; }


		WORD dwKorTmp = ( hiKorByte - 0xA0) * 0xA0;	// 96*96
		dwKorTmp += (loKorByte - 0xA0);		

		dwKorTmp += 95;
		if(dwKorTmp > 3074) dwKorTmp += 44;
		if(dwKorTmp > 4535) dwKorTmp += 12096;
		if(dwKorTmp > 18622) dwKorTmp += 466;
		if(dwKorTmp > 19450) return FALSE;

		BYTE hiByte = (dwKorTmp / 189) + 0x88;
		BYTE loByte = (dwKorTmp % 189) + 0x40;
		dwKorTmp = MAKEWORD( loByte, hiByte );

		if( 0x889F <= dwKorTmp && dwKorTmp <= 0xEEEC )
		{
			szJpnCode[0] = HIBYTE(dwKorTmp);
			szJpnCode[1] = LOBYTE(dwKorTmp);

			bRetVal = TRUE;
		}
	}

	return bRetVal;
}